package dev.shadowsoffire.apotheosis.adventure.client;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemItem;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.List;
import net.minecraft.client.Minecraft;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.block.model.ItemOverrides;
import net.minecraft.client.renderer.block.model.ItemTransforms;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.resources.model.BakedModel;
import net.minecraft.client.resources.model.ModelBakery;
import net.minecraft.core.Direction;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.RandomSource;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.state.BlockState;
import org.jetbrains.annotations.Nullable;

public class GemModel implements BakedModel {
  private final BakedModel original;
  
  private final ItemOverrides overrides;
  
  public GemModel(BakedModel original, ModelBakery loader) {
    this.original = original;
    this.overrides = (ItemOverrides)new Object(this);
  }
  
  public BakedModel resolve(BakedModel original, ItemStack stack, @Nullable ClientLevel world, @Nullable LivingEntity entity, int seed) {
    DynamicHolder<Gem> gem = GemItem.getGem(stack);
    if (gem.isBound())
      return Minecraft.m_91087_().m_91304_().getModel(new ResourceLocation("apotheosis", "item/gems/" + gem.getId().m_135815_())); 
    return original;
  }
  
  public ItemOverrides m_7343_() {
    return this.overrides;
  }
  
  @Deprecated
  public List<BakedQuad> m_213637_(BlockState pState, Direction pDirection, RandomSource pRandom) {
    return this.original.m_213637_(pState, pDirection, pRandom);
  }
  
  public boolean m_7541_() {
    return this.original.m_7541_();
  }
  
  public boolean m_7539_() {
    return this.original.m_7539_();
  }
  
  public boolean m_7547_() {
    return this.original.m_7547_();
  }
  
  public boolean m_7521_() {
    return this.original.m_7521_();
  }
  
  @Deprecated
  public TextureAtlasSprite m_6160_() {
    return this.original.m_6160_();
  }
  
  @Deprecated
  public ItemTransforms m_7442_() {
    return this.original.m_7442_();
  }
}
